#ifndef INCLUDED_SINGLETON_H
#define INCLUDED_SINGLETON_H

#pragma warning(disable : 4786)

#include <memory>

using namespace std;

template <class Type>

class Singleton
{
	public:

		static Type * getInstance(void) 
		{
			if (m_instance.get() == NULL)
			{
				m_instance = auto_ptr<Type>(new Type());
			}

			return m_instance.get();
		}

	protected:

		Singleton(void) {};

	private:

		static auto_ptr<Type> m_instance;
};

template <class Type>
auto_ptr<Type> Singleton<Type>::m_instance = auto_ptr<Type>(NULL);

#endif