//
// dl.h: include file for dynamic linking
//

#ifndef __DL_H__
#define __DL_H__

#ifdef WIN32	
#include <windows.h>
#else	// Linux
#include <dlfcn.h>
#endif

// DL library handle
#ifdef WIN32
typedef HINSTANCE DLHANDLE;
#else
typedef void *DLHANDLE;
#endif

// functions
DLHANDLE DL_OpenLibrary(char *libname);
bool DL_CloseLibrary(DLHANDLE dlhandle);
void *DL_BindFunction(DLHANDLE dlhandle, char *symbol);

#endif